/**
 * Copyright bradsedito ( http://wonderfl.net/user/bradsedito )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/6y2b
 */

package 
{
    import flash.display.*;
    import flash.geom.*;
    import flash.events.*;
    import flash.utils.*;
    import flash.geom.*;
    import flash.filters.BlurFilter;
    import com.greensock.*;
    import com.greensock.easing.*;
    import net.hires.debug.Stats;
    
    public class Liquid3D extends Sprite {
        private const NUM_PARTICLE:uint = 50;
        private var bmpData:BitmapData = new BitmapData( 465, 465, false, 0x000000 );
        private var forceMap:BitmapData = new BitmapData( 233, 233, false, 0x000000 );
        private var randomSeed:uint = Math.floor( Math.random() * 0xFFFF );
        private var particleList:Vector.<Particle> = new Vector.<Particle>(NUM_PARTICLE, true);
        private var rect:Rectangle = new Rectangle( 0, 0, 465, 465 );
        private var seed:Number = Math.floor( Math.random() * 0xFFFF );
        private var offset:Array = [new Point(), new Point()];
        private var colorTransform:ColorTransform = new ColorTransform( 0.60, 0.00, 0.90, 0.00 );
        private var timer:Timer;
        private var world:Sprite = new Sprite();

        public function Liquid3D() 
        {
            //var projection:PerspectiveProjection = this.transform.perspectiveProjection;
            //var ppc:Point = new Point(stage.stageWidth / 2, stage.stageHeight / 2);;
            //projection.projectionCenter = ppc;
            //projection.fieldOfView = 120;

            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.quality = StageQuality.BEST;
            stage.frameRate = 60;
            addChild(new Bitmap( bmpData )) as Bitmap;
            //addChild(new Bitmap( forceMap )) as Bitmap;
            
            resetFunc();
            
            for (var i:uint = 0; i < NUM_PARTICLE; i++) {
                var px:Number = Math.random() * 465;
                var py:Number = Math.random() * 465;
                var pz:Number = Math.random() * 465 * 2 - 465;
                particleList[i] = new Particle(px, py, pz);
                world.addChild(particleList[i]);
            }
            
            addEventListener( Event.ENTER_FRAME, loop );
            
            var timer:Timer = new Timer(500)
            timer.addEventListener(TimerEvent.TIMER, resetFunc);
            timer.start();
            addChild(new Stats);
        }
        
        private function loop( e:Event ):void 
        {
            var len:uint = particleList.length;
            var col:Number;
            
            for (var i:uint = 0; i < len; i++) 
            {               
                var  posX   :Number;
                var  posY   :Number;
                var  posZ   :Number; 
                var  bF     :Number      = 1 * (posZ*0.1);                 
                var  bB     :Number      = 1 * (posZ*0.1);               
                var  blurF  :BlurFilter  = new BlurFilter(  bF, bF,3 );
                var  blurB  :BlurFilter  = new BlurFilter( -bB,-bB,3 );
                var  MainTL :TimelineMax = new TimelineMax({timeScale:6});            
                // var MainTL :TimelineMax= new TimelineMax({repeat:4.0, yoyo:true, repeatDelay:2.0});            
                posX += particleList[i].x; 
                posY += particleList[i].y; 
                posZ += particleList[i].z; 
                particleList[i].filters = [ blurF,blurB ];
    
                MainTL.append
                (        
                    TweenMax.to(particleList[i], 10, 
                    // TweenMax.to(particleList[i] as Sprite, 0, 
                    {
                       // x: particleList[i].x++, // _posX + (_posX * Math.random()),  
                       // y: particleList[i].y++, // _posY + (_posZ * Math.random()), 
                        z: particleList[i].z++ // _posZ + (_posZ * Math.random()) 
                    }) 
                );
                var dots:Particle = particleList[i];
                var _posX:Number = dots.x;
                var _posY:Number = dots.y;
                var _posZ:Number = dots.z;

//                col = forceMap.getPixel( dots.x >> 1, dots.y >> 1);
   //             dots.vx += dots.ax;
  //              dots.vy += dots.ay;
 //               dots.vz += dots.az;
    //            dots.ax *= .65;
    //            dots.ay *= .65;
   //             dots.az *= .65;
 ///               dots.vx *= .65;
//                dots.vy *= .65;
 ///               var dvX:Number;
   //             var dvY:Number;
       //         var dvZ:Number;
    //            dvX = (dots.vx *= .65) ;
     //           dvY = (dots.vy *= .65) ;
      //          dvZ = (dots.vz *= .65) ;
       //      // dots.ax += ( (col >> 8 & 0xff) - 128 ) * .0005;
             // dots.ay += ( (col >> 4  & 0xff) - 128 ) * .0005;
             // dots.az += ( (col >> 16  & 0xff) - 128 ) * .0005;
             // dots.x  += dots.vx;
             // dots.y  += dots.vy;
             // dots.z  += dots.vz;
                                
                ( _posX > 465 ) ? dots.x = 0 :
                    ( _posX < 0 ) ? dots.x = 465 : 0;
                ( _posY > 465 ) ? dots.y = 0 :
                    ( _posY < 0 ) ? dots.y = 465 : 0;
                ( _posZ > 465 ) ? dots.z = -465 :
                    ( _posZ < -465 ) ? dots.z = 465 : 0;
            }
            
            bmpData.colorTransform(rect, colorTransform);
            bmpData.draw(world);
        }
        
        private function resetFunc(e:Event = null):void{
            forceMap.perlinNoise(233, 233, 3, seed, false, false, 1|2|4|0, false, offset );
            offset[0].x += 1.5;
            offset[1].y += 1;
            seed = Math.floor( Math.random() * 0xFFFFFF );
        }
    }
}

import flash.display.Sprite;

class Particle extends Sprite{
    public var vx:Number = 0;
    public var vy:Number = 0;
    public var vz:Number = 0;
    public var ax:Number = 0;
    public var ay:Number = 0;
    public var az:Number = 0;

    function Particle( x:Number, y:Number, z:Number ) {
        this.x = x;
        this.y = y;
        this.z = z;
        
        graphics.beginFill(0xFFFFFF);
        graphics.drawCircle( -1, -1, 3);
    }
}